unit uOptions;

{
*******************************************************************************
* Descriptions: Main Unit for FMA
* $Source: /cvsroot/fma/fma/uOptions.pas,v $
* $Locker:  $
*
* Todo:
*
* Change Log:
* $Log: uOptions.pas,v $
* Revision 1.20  2004/06/11 12:29:22  z_stoichev
* Options windows enlarged.
* Outlook folders icons usage.
* Show current SMS counter.
*
* Revision 1.19  2004/06/05 13:32:55  lordlarry
* Merged with OutlookSync branch
*
* Revision 1.18  2004/05/21 10:09:05  z_stoichev
* Changed logging handle routines.
*
* Revision 1.17  2004/05/19 18:34:16  z_stoichev
* Build 0.1.0.35c
*
* Revision 1.16  2004/03/26 18:37:40  z_stoichev
* Build 0.1.0.35 RC5
*
* Revision 1.15  2004/03/14 18:47:38  z_stoichev
* Remember Last User Profile option.
*
* Revision 1.14  2004/03/08 12:21:29  z_stoichev
* Access serial port by name.
*
* Revision 1.13  2004/01/15 14:13:56  z_stoichev
* Added SMS Counter and Warning level.
*
* Revision 1.12  2004/01/14 15:04:59  z_stoichev
* Pascal Scripting support.
*
* Revision 1.11  2003/12/17 17:15:22  z_stoichev
* Added Option to turn off notifications for unsent messages.
*
* Revision 1.10  2003/12/12 16:55:36  z_stoichev
* Added options for do not load Calls and Profiles on connect.
*
* Revision 1.9  2003/11/28 09:38:07  z_stoichev
* Merged with branch-release-1-1 (Fma 0.10.28c)
*
* Revision 1.8.2.8  2003/11/21 10:59:46  z_stoichev
* Tab order fixed, GUI changes.
* Outlook and other preparations.
* Test proximity caption change.
*
* Revision 1.8.2.7  2003/11/12 15:02:11  z_stoichev
* Proximity detection options changed.
*
* Revision 1.8.2.6  2003/11/11 13:12:51  z_stoichev
* New options introduced.
*
* Revision 1.8.2.5  2003/11/10 14:03:10  z_stoichev
* RC3
*
* Revision 1.8.2.4  2003/10/31 14:50:33  z_stoichev
* Proximity preparations.
*
* Revision 1.8.2.3  2003/10/29 12:02:43  z_stoichev
* Options to disable Obex, IrmcSync and to
* disable initial loading of Gruops and Folders.
*
* Revision 1.8.2.2  2003/10/28 12:59:38  z_stoichev
* Added option to select clock sync mode.
* Some GUI changes, added some texts.
* Prepare for protocol advanced options.
*
* Revision 1.8.2.1  2003/10/27 07:22:54  z_stoichev
* Build 0.1.0 RC1 Initial Checkin.
*
* Revision 1.8  2003/10/22 13:18:09  z_stoichev
* Add checkbox for Progress dialog usage.
* Add checkbox for Show progress dialog on long operations.
* Add checkbox for Move SMS to Archive warning.
* GUI changed.
*
* Revision 1.7  2003/10/17 09:14:59  z_stoichev
* Default Obex packet size set to 255 (by specs).
* Added header comments.
* Changed GUI.
*
*
* 04/02/2003 - Modified by Crino
* Added the synchronize option
* General tab renamed in Window
*
*******************************************************************************
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, RXSpin, ComCtrls, Placemnt, ExtCtrls, Spin,
  TntStdCtrls, Mask, CPortCtl, VirtualTrees, Outlook8, ImgList;

type
  TfrmOptions = class(TForm)
    PageControl1: TPageControl;
    Button1: TButton;
    Button2: TButton;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    groupSerialPortSetup: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    cbRTSFlow: TComboBox;
    cbDTRFlow: TComboBox;
    TabSheet3: TTabSheet;
    cbObexPacketSize: TGroupBox;
    seMaxPacketSize: TEdit;
    seMaxPacketSizeSpin: TUpDown;
    lblObexPacketSize: TLabel;
    GroupBox3: TGroupBox;
    Label11: TLabel;
    seCommTimeout: TEdit;
    seCommTimeoutSpin: TUpDown;
    GroupBox4: TGroupBox;
    sePolling: TEdit;
    sePollingSpin: TUpDown;
    Label5: TLabel;
    TabSheet4: TTabSheet;
    lbScriptType: TLabel;
    OpenDialog1: TOpenDialog;
    Label10: TLabel;
    Label12: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    Label8: TLabel;
    rbUseSerial: TRadioButton;
    rbUseIRDA: TRadioButton;
    rbUseBluetooth: TRadioButton;
    groupBluetoothSetup: TGroupBox;
    edBTAddress: TMaskEdit;
    Label13: TLabel;
    edBTPort: TEdit;
    edBTPortSpin: TUpDown;
    Label14: TLabel;
    Label15: TLabel;
    TabSheet6: TTabSheet;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    seComposeSpin: TUpDown;
    seCompose: TEdit;
    seMessage: TEdit;
    seMessageSpin: TUpDown;
    seCall: TEdit;
    seCallSpin: TUpDown;
    seDebug: TEdit;
    seDebugSpin: TUpDown;
    GroupBox5: TGroupBox;
    Label19: TLabel;
    Label20: TLabel;
    chkCallM: TCheckBox;
    chkMsgM: TCheckBox;
    TabSheet5: TTabSheet;
    rbSync: TRadioGroup;
    GroupBox6: TGroupBox;
    chkStateMonitor: TCheckBox;
    GroupBox7: TGroupBox;
    chkMinButton: TCheckBox;
    TabSheet7: TTabSheet;
    GroupBox9: TGroupBox;
    cbStrictUCScheck: TCheckBox;
    TabSheet8: TTabSheet;
    GroupBox8: TGroupBox;
    cbProgressLongOnly: TCheckBox;
    cbDontProgress: TCheckBox;
    rbPhoneClockSync: TRadioGroup;
    GroupBox10: TGroupBox;
    cbNoObex: TCheckBox;
    Label22: TLabel;
    cbNoIRMC: TCheckBox;
    TntLabel1: TTntLabel;
    GroupBox11: TGroupBox;
    cbNoGroups: TCheckBox;
    cbNoFolders: TCheckBox;
    Label9: TLabel;
    Label23: TLabel;
    TabSheet9: TTabSheet;
    GroupBox2: TGroupBox;
    cbProximityLock: TCheckBox;
    cbProximityUnlock: TCheckBox;
    Label24: TLabel;
    Label25: TLabel;
    rgProximityAway: TRadioGroup;
    rgProximityNear: TRadioGroup;
    CheckBox1: TCheckBox;
    cbRunSS: TCheckBox;
    GroupBox12: TGroupBox;
    edScriptPath: TTntEdit;
    Button3: TButton;
    CheckBox2: TCheckBox;
    Label4: TLabel;
    CheckBox5: TCheckBox;
    Button4: TButton;
    Label26: TLabel;
    cbAutoInbox: TCheckBox;
    cbAutoSync: TCheckBox;
    cbProgressRestoredOnly: TCheckBox;
    cbDiagram: TCheckBox;
    cbNoMsgPopup: TCheckBox;
    cbMsgToArchive: TCheckBox;
    cbNoMsgBaloon: TCheckBox;
    btnProximityTest: TButton;
    cbNoProfiles: TCheckBox;
    cbNoCalls: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox11: TCheckBox;
    rbBookmarks: TRadioGroup;
    cbCheckOutbox: TCheckBox;
    Label27: TLabel;
    GroupBox13: TGroupBox;
    cbSMSWarning: TCheckBox;
    udSMSCnt: TUpDown;
    edSMSCnt: TEdit;
    cbSMSReset: TCheckBox;
    udSMSCntRst: TUpDown;
    edSMSCntRst: TEdit;
    Label28: TLabel;
    rgExplorer: TRadioGroup;
    Button6: TButton;
    TabSheet10: TTabSheet;
    rbOutlookSync: TRadioGroup;
    grOutlookConfirmation: TGroupBox;
    cbConfirmAdding: TCheckBox;
    cbConfirmUpdating: TCheckBox;
    cbConfirmDeleting: TCheckBox;
    grOutlookCategories: TGroupBox;
    mmoOutlookCategories: TMemo;
    cbOutlookAllCategories: TCheckBox;
    btAddCat: TButton;
    btDelCat: TButton;
    rbOutlookNewAction: TRadioGroup;
    TabSheet11: TTabSheet;
    cbAutoProfile: TCheckBox;
    sePort: TComComboBox;
    cbBaudrate: TComComboBox;
    Label29: TLabel;
    CheckBox3: TCheckBox;
    Button7: TButton;
    OutlookImageList: TImageList;
    lblSMSCount: TLabel;
    Label21: TLabel;
    CheckBox4: TCheckBox;
    Bevel1: TBevel;
    GroupBox14: TGroupBox;
    tvOutlookFolders: TVirtualStringTree;
    procedure edScriptPathChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure rbUseSerialClick(Sender: TObject);
    procedure cbDontProgressClick(Sender: TObject);
    procedure cbNoObexClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure chkMsgMClick(Sender: TObject);
    procedure btnProximityTestClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure cbOutlookAllCategoriesClick(Sender: TObject);
    procedure btAddCatClick(Sender: TObject);
    procedure mmoOutlookCategoriesClick(Sender: TObject);
    procedure btDelCatClick(Sender: TObject);
      procedure tvOutlookFoldersFreeNode(Sender: TBaseVirtualTree;
      Node: PVirtualNode);
    procedure tvOutlookFoldersGetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure tvOutlookFoldersInitChildren(Sender: TBaseVirtualTree;
      Node: PVirtualNode; var ChildCount: Cardinal);
    procedure tvOutlookFoldersInitNode(Sender: TBaseVirtualTree;
      ParentNode, Node: PVirtualNode;
      var InitialStates: TVirtualNodeInitStates);
    procedure FormDestroy(Sender: TObject);
    procedure cbNoProfilesClick(Sender: TObject);
    procedure chkStateMonitorClick(Sender: TObject);
    procedure tvOutlookFoldersGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
  private
    Outlook: OutlookApplication;
    NmSpace: NameSpace;
    FSelectedOutlookFolders: TStringList;
    procedure SanityCheck;
    procedure ReadOutlookFolders;
    function GetSelectedOutlookFolders: String;
    procedure SetSelectedOutlookFolders(const Value: String);
    procedure LoadSelectedOutlookFolder(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Data: Pointer; var Abort: Boolean);
    procedure SaveSelectedOutlookFolder(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Data: Pointer; var Abort: Boolean);
  public
    connectionType: Integer;
    property SelectedOutlookFolders: String read GetSelectedOutlookFolders write SetSelectedOutlookFolders;
  end;

var
  frmOptions: TfrmOptions;

implementation

uses Unit1, uComposeSMS;

{$R *.dfm}

type
  TOutlookFolder = record
    Folder: MAPIFolder;
  end;
  POutlookFolder = ^TOutlookFolder;

procedure TfrmOptions.edScriptPathChange(Sender: TObject);
begin
  lbScriptType.Caption := LowerCase(ExtractFileExt(edScriptPath.Text));
  lbScriptType.Caption := Copy(lbScriptType.Caption, 2, length(lbScriptType.Caption));
end;

procedure TfrmOptions.Button3Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    edScriptPath.Text := OpenDialog1.FileName;
end;

procedure TfrmOptions.FormShow(Sender: TObject);
begin
  edScriptPathChange(nil);
  case connectionType of
  0: rbUseSerialClick(rbUseBluetooth);
  1: rbUseSerialClick(rbUseIRDA);
  2: rbUseSerialClick(rbUseSerial);
  end;
  PageControl1.ActivePageIndex := 0;
  cbOutlookAllCategoriesClick(Self);
  lblSMSCount.Caption := 'Messages sent so far:  '+IntToStr(Form1.FSMSCounter);
end;

procedure TfrmOptions.rbUseSerialClick(Sender: TObject);
begin
  if not (Sender as TRadioButton).Checked then
    (Sender as TRadioButton).Checked := True;

  case (Sender as TRadioButton).Tag of
  0:
    begin
      groupBluetoothSetup.Enabled := True;
      groupSerialPortSetup.Enabled := False;
    end;
  1:
    begin
      groupBluetoothSetup.Enabled := False;
      groupSerialPortSetup.Enabled := False;
    end;
  2:
    begin
      groupBluetoothSetup.Enabled := False;
      groupSerialPortSetup.Enabled := True;
    end;
  end;

  connectionType := (Sender as TRadioButton).Tag;
end;

procedure TfrmOptions.cbDontProgressClick(Sender: TObject);
begin
  cbProgressLongOnly.Enabled := not cbDontProgress.Checked;
  cbProgressRestoredOnly.Enabled := not cbDontProgress.Checked;
end;

procedure TfrmOptions.cbNoObexClick(Sender: TObject);
begin
  if cbNoObex.Checked then begin
    { If no obex, disable other as well }
    cbNoIRMC.Checked := True;
    cbNoFolders.Checked := True;
    {}
    cbNoIRMC.Enabled := False;
    cbNoFolders.Enabled := False;
    rbSync.Enabled := False;
    cbObexPacketSize.Enabled := False;
    lblObexPacketSize.Enabled := False;
  end
  else begin
    cbNoIRMC.Enabled := True;
    cbNoFolders.Enabled := True;
    rbSync.Enabled := True;
    cbObexPacketSize.Enabled := True;
    lblObexPacketSize.Enabled := True;
  end;
end;

procedure TfrmOptions.ReadOutlookFolders;
begin
  tvOutlookFolders.NodeDataSize := SizeOf(TOutlookFolder);
  tvOutlookFolders.RootNodeCount := NmSpace.Folders.Count;
end;

procedure TfrmOptions.FormCreate(Sender: TObject);
begin
{$IFNDEF VER150}
  Form1.ThemeManager1.CollectForms(Self);
{$ENDIF}
  { Make important widgets bold }
  Label24.Font.Style := [fsBold];
  Label25.Font.Style := [fsBold];
  lbScriptType.Font.Style := [fsBold];
  rbUseBluetooth.Font.Style := [fsBold];
  rbUseIRDA.Font.Style := [fsBold];
  rbUseSerial.Font.Style := [fsBold];
  lblSMSCount.Font.Style := [fsBold];

  mmoOutlookCategories.Lines.Delimiter := ';';

  try
    Outlook := CoOutlookApplication.Create;
    NmSpace := Outlook.GetNamespace('MAPI');

    ReadOutlookFolders;
  except
    Outlook := nil;
    NmSpace := nil;
    tvOutlookFolders.RootNodeCount := 0;
  end;
  FSelectedOutlookFolders := TStringList.Create;
end;

procedure TfrmOptions.Button1Click(Sender: TObject);
begin
  SanityCheck;
  ModalResult := mrOk;
end;

procedure TfrmOptions.Button4Click(Sender: TObject);
begin
  seComposeSpin.Position := 200;
  seMessageSpin.Position := 200;
  seCallSpin.Position := 200;
  seDebugSpin.Position := 200;
end;

procedure TfrmOptions.chkMsgMClick(Sender: TObject);
begin
  cbNoMsgPopup.Enabled := chkMsgM.Checked;
  cbNoMsgBaloon.Enabled := chkMsgM.Checked;
  cbMsgToArchive.Enabled := chkMsgM.Checked;
end;

procedure TfrmOptions.btnProximityTestClick(Sender: TObject);
begin
  SanityCheck;
  btnProximityTest.Enabled := False;
  btnProximityTest.Caption := 'Testing...';
  try
    Form1.DoProximityTest;
  finally
    btnProximityTest.Enabled := True;
    btnProximityTest.Caption := 'Test Proximity';
  end;
end;

procedure TfrmOptions.SanityCheck;
begin
  if (rgProximityAway.ItemIndex = rgProximityNear.ItemIndex) and (rgProximityAway.ItemIndex <> 4) then
    raise Exception.Create('Proximity settings cannot match for Away and Near');
end;

procedure TfrmOptions.Button6Click(Sender: TObject);
begin
  Form1.FSMSCounter := 0;
  Form1.FSMSCounterReseted := True;
  if NewMsgForm.Visible then NewMsgForm.FormActivate(NewMsgForm);
  lblSMSCount.Caption := 'Messages sent: '+IntToStr(Form1.FSMSCounter);
end;

procedure TfrmOptions.cbOutlookAllCategoriesClick(Sender: TObject);
begin
  mmoOutlookCategories.Enabled := not cbOutlookAllCategories.Checked;
  if mmoOutlookCategories.Enabled then
    mmoOutlookCategories.Color := clWindow
  else
    mmoOutlookCategories.Color := clBtnFace;
  btAddCat.Enabled := mmoOutlookCategories.Enabled;
end;

procedure TfrmOptions.btAddCatClick(Sender: TObject);
var
  s: string;
begin
  if InputQuery('Add Category...','Enter category name:',s) then
    mmoOutlookCategories.Lines.Add(Trim(s));
end;

procedure TfrmOptions.mmoOutlookCategoriesClick(Sender: TObject);
var
  i,j: integer;
begin
  i := 0; j := 0;
  while (i < mmoOutlookCategories.Lines.Count) and
    (j + Length(mmoOutlookCategories.Lines[i]) < mmoOutlookCategories.SelStart) do begin
      inc(j,Length(mmoOutlookCategories.Lines[i])+2);
      inc(i);
    end;
  if i < mmoOutlookCategories.Lines.Count then begin
    mmoOutlookCategories.SelStart := j;
    mmoOutlookCategories.SelLength := Length(mmoOutlookCategories.Lines[i]);
  end
  else
    mmoOutlookCategories.SelLength := 0;
  btDelCat.Enabled := mmoOutlookCategories.SelLength <> 0;
end;

procedure TfrmOptions.btDelCatClick(Sender: TObject);
var
  i: integer;
begin
  i := mmoOutlookCategories.Lines.IndexOf(mmoOutlookCategories.SelText);
  if i <> -1 then begin
    mmoOutlookCategories.Lines.Delete(i);
    btDelCat.Enabled := False;
  end;
end;

procedure TfrmOptions.tvOutlookFoldersFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
var OutlookFolder: POutlookFolder;
begin
  OutlookFolder := Sender.GetNodeData(Node);
  if Assigned(OutlookFolder) then
    Finalize(OutlookFolder^)
end;

procedure TfrmOptions.tvOutlookFoldersGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var OutlookFolder: POutlookFolder;
begin
  OutlookFolder := Sender.GetNodeData(Node);
  if Assigned(OutlookFolder) and Assigned(OutlookFolder.Folder) then
    CellText := OutlookFolder.Folder.Name
  else
    CellText := 'Unknown';
end;

procedure TfrmOptions.tvOutlookFoldersInitChildren(
  Sender: TBaseVirtualTree; Node: PVirtualNode; var ChildCount: Cardinal);
var OutlookFolder: POutlookFolder;
begin
  OutlookFolder := Sender.GetNodeData(Node);
  if Assigned(OutlookFolder) and Assigned(OutlookFolder.Folder) then
    ChildCount := OutlookFolder.Folder.Folders.Count
  else
    ChildCount := 0;
end;

procedure TfrmOptions.tvOutlookFoldersInitNode(Sender: TBaseVirtualTree;
  ParentNode, Node: PVirtualNode;
  var InitialStates: TVirtualNodeInitStates);
var OutlookFolder, ParentOutlookFolder: POutlookFolder;
begin
  OutlookFolder := Sender.GetNodeData(Node);
  ParentOutlookFolder := Sender.GetNodeData(ParentNode);

  if Assigned(OutlookFolder) then begin
    if Assigned(ParentOutlookFolder) then
      OutlookFolder.Folder := ParentOutlookFolder.Folder.Folders.Item(Node.Index + 1)
    else
      OutlookFolder.Folder := NmSpace.Folders.Item(Node.Index + 1);

    if Assigned(OutlookFolder.Folder) then
      if OutlookFolder.Folder.Folders.Count > 0 then
        Include(InitialStates, ivsHasChildren);
  end;

  Node.CheckType := ctTriStateCheckBox;
  Include(InitialStates, ivsExpanded);
end;

procedure TfrmOptions.SaveSelectedOutlookFolder(Sender: TBaseVirtualTree; Node: PVirtualNode; Data: Pointer; var Abort: Boolean);
var OutlookFolder: POutlookFolder;
begin
  if Node.CheckState = csCheckedNormal then begin
    OutlookFolder := tvOutlookFolders.GetNodeData(Node);
    if Assigned(OutlookFolder) and Assigned(OutlookFolder.Folder) then
      FSelectedOutlookFolders.Add(OutlookFolder.Folder.EntryID);
  end;
end;

procedure TfrmOptions.LoadSelectedOutlookFolder(Sender: TBaseVirtualTree; Node: PVirtualNode; Data: Pointer; var Abort: Boolean);
var OutlookFolder: POutlookFolder;
begin
  OutlookFolder := tvOutlookFolders.GetNodeData(Node);
  if Assigned(OutlookFolder) and Assigned(OutlookFolder.Folder) then begin
    if FSelectedOutlookFolders.IndexOf(OutlookFolder.Folder.EntryID) <> -1 then
      tvOutlookFolders.CheckState[Node] := csCheckedNormal
    else
      tvOutlookFolders.CheckState[Node] := csUnCheckedNormal;
  end;
end;

function TfrmOptions.GetSelectedOutlookFolders: String;
begin
  FSelectedOutlookFolders.Clear;

  tvOutlookFolders.IterateSubtree(nil, SaveSelectedOutlookFolder, nil, [], True);

  Result := FSelectedOutlookFolders.DelimitedText;
end;

procedure TfrmOptions.SetSelectedOutlookFolders(const Value: String);
var Folder: MAPIFolder;
begin
  FSelectedOutlookFolders.DelimitedText := Value;

  if (FSelectedOutlookFolders.DelimitedText = 'DEFAULT') and Assigned(NmSpace) then begin
    Folder := NmSpace.GetDefaultFolder(olFolderContacts);
    if Assigned(Folder) then
      FSelectedOutlookFolders.DelimitedText := Folder.EntryID;
  end;

  tvOutlookFolders.IterateSubtree(nil, LoadSelectedOutlookFolder, nil, [], True);
end;

procedure TfrmOptions.FormDestroy(Sender: TObject);
begin
  FSelectedOutlookFolders.Free;
end;

procedure TfrmOptions.cbNoProfilesClick(Sender: TObject);
begin
  if cbNoProfiles.Checked then begin
    cbAutoProfile.Checked := False;
    cbAutoProfile.Enabled := False;
  end
  else
    cbAutoProfile.Enabled := True;
end;

procedure TfrmOptions.chkStateMonitorClick(Sender: TObject);
begin
  cbDiagram.Enabled := chkStateMonitor.Checked;
  if not cbDiagram.Enabled then cbDiagram.Checked := False;
end;

procedure TfrmOptions.tvOutlookFoldersGetImageIndex(
  Sender: TBaseVirtualTree; Node: PVirtualNode; Kind: TVTImageKind;
  Column: TColumnIndex; var Ghosted: Boolean; var ImageIndex: Integer);
var OutlookFolder: POutlookFolder;
begin
  OutlookFolder := Sender.GetNodeData(Node);
  if Assigned(OutlookFolder) and Assigned(OutlookFolder.Folder) then
    case OutlookFolder.Folder.DefaultItemType of
      olMailItem:        ImageIndex := 1;
      olAppointmentItem: ImageIndex := 2;
      olContactItem:     ImageIndex := 3;
      olTaskItem:        ImageIndex := 4;
      olJournalItem:     ImageIndex := 5;
      olNoteItem:        ImageIndex := 6;
      olPostItem:        ImageIndex := 7;
      else ImageIndex := 0;
    end
  else
    ImageIndex := -1;
end;

end.
