unit uPromptConflict;

{
*******************************************************************************
* Descriptions: Interface to solve the conflits during synchronize's phonebook
* $Source: /cvsroot/fma/fma/uPromptConflict.pas,v $
* $Locker:  $
*
* Todo:
*
* Change Log:
* $Log: uPromptConflict.pas,v $
* Revision 1.3  2004/06/05 13:32:56  lordlarry
* Merged with OutlookSync branch
*
* Revision 1.2.4.2  2004/05/17 12:45:12  z_stoichev
* Build 0.1.1.10 beta 2
*
* Revision 1.2.4.1  2004/03/08 17:43:00  lordlarry
* Added properties so it could also be used in the Outlook Synchronization part
*
* Revision 1.2  2003/11/28 09:38:07  z_stoichev
* Merged with branch-release-1-1 (Fma 0.10.28c)
*
* Revision 1.1.2.1  2003/10/27 07:22:54  z_stoichev
* Build 0.1.0 RC1 Initial Checkin.
*
* Revision 1.1  2003/02/14 14:23:54  crino77
* Initial Checkin
*
* $Revision: 1.3 $
*
*
*******************************************************************************
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmPromptConflict = class(TForm)
    Button1: TButton;
    grpConflict: TRadioGroup;
    Label1: TLabel;
    lblInfo: TLabel;
    lblContact: TLabel;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
  private
    function GetInfo: String;
    function GetItem0Name: String;
    function GetItem1Name: String;
    function GetSelectedItem: Integer;
    procedure SetInfo(const Value: String);
    procedure SetItem0Name(const Value: String);
    procedure SetItem1Name(const Value: String);
    procedure SetSelectedItem(const Value: Integer);
    function GetContact: String;
    procedure SetContact(const Value: String);
  public
    property Contact: String read GetContact write SetContact;
    property Info: String read GetInfo write SetInfo;
    property Item0Name: String read GetItem0Name write SetItem0Name;
    property Item1Name: String read GetItem1Name write SetItem1Name;
    property SelectedItem: Integer read GetSelectedItem write SetSelectedItem;
  end;

var
  frmPromptConflict: TfrmPromptConflict;

implementation

{$R *.dfm}

{ TfrmPromptConflict }

function TfrmPromptConflict.GetContact: String;
begin
  Result := lblContact.Caption;
end;

function TfrmPromptConflict.GetInfo: String;
begin
  Result := lblInfo.Caption;
end;

function TfrmPromptConflict.GetItem0Name: String;
begin
  Result := grpConflict.Items[0];
end;

function TfrmPromptConflict.GetItem1Name: String;
begin
  Result := grpConflict.Items[1];
end;

function TfrmPromptConflict.GetSelectedItem: Integer;
begin
  Result := grpConflict.ItemIndex;
end;

procedure TfrmPromptConflict.SetContact(const Value: String);
begin
  lblContact.Caption := Value;
end;

procedure TfrmPromptConflict.SetInfo(const Value: String);
begin
  lblInfo.Caption := Value;
end;

procedure TfrmPromptConflict.SetItem0Name(const Value: String);
begin
  grpConflict.Items[0] := Value;
end;

procedure TfrmPromptConflict.SetItem1Name(const Value: String);
begin
  grpConflict.Items[1] := Value;
end;

procedure TfrmPromptConflict.SetSelectedItem(const Value: Integer);
begin
  grpConflict.ItemIndex := Value;
end;

procedure TfrmPromptConflict.Button2Click(Sender: TObject);
begin
  Close;
  raise Exception.Create('Contacts linking aborted by user');
end;

end.
